
{*******************************************************}
{       Modified from                                   }
{       Delphi Visual Component Library                 }
{       Valcombo for 32bit by ACS                       }
{                                                       }
{                                                       }
{       Copyright (c) 1995,96 Borland International     }
{       and OnTYme Software and ACS                     }
{                                                       }
{*******************************************************}


(*Code follows this intro*)
{

THIS IS A 32 BIT VERSION OF A 16 BIT VCL CONTROL FROM THE DELPHI FORUM ON 
COMPUSERVE

The 16 bit version is available on the Delphi forum, search on Valcombo.*.

The original writer's (Tim Young) intro follows, followed by a bit by me, Andrew Skinner.



TDBValueComboBox component for Borland Delphi

Do you need a lookup type of combo box where the descriptive items are
displayed, but a one character code is actually stored in the data field but
don't want to mess with the TDBLookupComboBox because you don't need another
darn TTable open on the form ?  Well, here's the component for you.

Freeware, including source, from OnTYme Software.

TDBValueComboBox is a descendant from TCustomComboBox that allows you to
specify not only the descriptive items for the drop down list, but also
the values you wish to have stored in data field when one of these descriptive
items is selected.  This is accomplished through a parallel TStrings property
called Values.  To use the component, simply hook up the DataSource to a
dataset and the DataField to the field that contains the *value* (i.e. one-
character code, etc.) data you wish to use.  Secondly, add the descriptive
items you want displayed in the drop down list in the Items property, and then
add the values for these items in the Values property.  Please make sure that
the appropriate values for the appropriate descriptive items are in the same
index position in the list, or you will get the *wrong* value stored in the
data field when that descriptive item is selected.

******************************************************************************
One note, the Sorted property is not available simply because sorting the
descriptive items would screw up the 1-1 relationship between the index
positions of the Items property and the Values property.
******************************************************************************

Well that's about it, if you have any questions or comments please let me
know at CServe ID 73302,2561 or you can give me a buzz at 407-246-0930.
Also, if you make any improvements to the component please send me a copy
so that I can implement in any future versions.

About me

I specialize in manufacturing applications, specifically make-to-order, and
am looking also to build some high level components for configurations and
bills of material.  I come from a FoxPro/Clipper background and am always
happy to swap stories about the differences, likes/dislikes, regarding the
two environments.  I personally don't like coding in FoxPro or Clipper too
much anymore if you know what I mean.  By the way, if you're located in
Orlando FL. and are interested, I'm looking to form a Delphi study/user group
to promote discussion regarding problems and solutions with Delphi in the
local community.  Give me a call and we'll talk some more.  My office is in
my home, but it's fairly large so I could probably fit about 10-12 people
tops.  I'm located in College Park in Orlando, in case you're wondering......

Tim Young
OnTYme Software


******************************************************************************
I make no warranties regarding the use of this component and will not be held
responsible for any damages incurred from the use of this component.  I will
try to fix any bugs found in a reasonably timely manner, but in the case of
this not happening you have the source so fix it yourself.
******************************************************************************

(C) Copyright 1995 OnTYme Software

From Andrew Skinner:-

All I have done is take the 16 bit code for ValCombo 
and compare it with the 32 bit code in the Delphi 2.0 VCL for DBComboBox. 
It seems to work OK, but I make all the exclusions referred to above.

If it does not work I would like to know, preferably with an
explanation and a fix, because the chances of me being able to fix it
are minute <BG>.


Bug Fix and Enhancement History

9/7/95	-	Original TDBValueComboBox
1/3/97  -       TBDValueComboBox for Delphi 2.0



Andrew Skinner Skinner_Doc@compuserve.com}




unit valcombo;

{$R-}

interface

uses SysUtils, Windows, Messages, Classes, Controls, Forms,
  Graphics, Menus, StdCtrls, ExtCtrls, DB, DBTables, Mask,
  Buttons, DbCtrls;

type

{ TDbValueCombobox }

  TDbValueCombobox = class(TCustomComboBox)
  private
    FDataLink: TFieldDataLink;
        FValues: TStrings;{new}
    FPaintControl: TPaintControl;
    procedure DataChange(Sender: TObject);
    procedure EditingChange(Sender: TObject);
    function GetValueText(const Value: string) : string;{changed from getcombotext}
    {function GetComboText: string;}
    function GetDataField: string;
    function GetDataSource: TDataSource;
    function GetField: TField;
    function GetReadOnly: Boolean;
    procedure SetComboText(const Value: string);
    procedure SetDataField(const Value: string);
    procedure SetDataSource(Value: TDataSource);
    procedure SetEditReadOnly;
    procedure SetItems(Value: TStrings);
    procedure SetReadOnly(Value: Boolean);
    procedure SetValues(Value: TStrings);{new}
    procedure UpdateData(Sender: TObject);
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure CMGetDataLink(var Message: TMessage); message CM_GETDATALINK;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    procedure Change; override;
    procedure Click; override;
    procedure ComboWndProc(var Message: TMessage; ComboWnd: HWnd;
      ComboProc: Pointer); override;
    procedure CreateWnd; override;
    procedure DropDown; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure SetStyle(Value: TComboboxStyle); override;
    procedure WndProc(var Message: TMessage); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Field: TField read GetField;
    property Text;
  published
    property Style; {Must be published before Items}
    property Color;
    property Ctl3D;
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property DragMode;
    property DragCursor;
    property DropDownCount;
    property Enabled;
    property Font;
    property ItemHeight;
    property Items write SetItems;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
    property ShowHint;
    {property Sorted;} {sorted must be removed}
    property TabOrder;
    property TabStop;
    property Values: TStrings read FValues write SetValues; {new}
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnStartDrag;
  end;

procedure Register;

implementation

uses BDE, Clipbrd, DBConsts, Dialogs;

(*{$R DBCTRLS}*)

procedure Register;
begin
	RegisterComponents('Data Controls',[TDbValueCombobox]);
end;

{ TDbValueCombobox }

constructor TDbValueCombobox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := Self;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnUpdateData := UpdateData;
  FDataLink.OnEditingChange := EditingChange;
  FValues := TStringList.Create;{new}
  FPaintControl := TPaintControl.Create(Self, 'COMBOBOX');
end;

destructor TDbValueCombobox.Destroy;
begin
  FPaintControl.Free;
  FDataLink.Free;
  FDataLink := nil;
  FValues.Free;{new}
  inherited Destroy;
end;

procedure TDbValueCombobox.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataLink <> nil) and
    (AComponent = DataSource) then DataSource := nil;
end;

procedure TDbValueCombobox.CreateWnd;
begin
  inherited CreateWnd;
  SetEditReadOnly;
end;

procedure TDbValueCombobox.DataChange(Sender: TObject);
begin
  if FDataLink.Field <> nil then
    SetComboText(FDataLink.Field.Text)
  else
    if csDesigning in ComponentState then
      SetComboText(Name)
    else
      SetComboText('');
end;

procedure TDbValueCombobox.UpdateData(Sender: TObject);
begin
  FDataLink.Field.Text := GetValueText(Text);{changed from GetComboText}
end;

procedure TDbValueCombobox.SetComboText(const Value: string);{this proc changed}
var
  I: Integer;
begin
	if Value = '' then I := -1 else I := Values.IndexOf(Value);
   ItemIndex := I;
	if (ItemIndex < 0) or (ItemIndex > (Items.Count-1)) then Text := '' else Text := Items[I];
end;

function TDbValueCombobox.GetValueText(const Value: string) : string;{different function}
var
  I: Integer;
begin
  if Style in [csDropDown, csSimple] then
		begin
			if Value = '' then I := -1 else I := Items.IndexOf(Value);
		   ItemIndex := I;
			if (ItemIndex < 0) or (ItemIndex > (Values.Count-1)) then Result := '' else Result := Values[I];
		end
  else
	  begin
	    I := ItemIndex;
	    if (ItemIndex < 0) or (ItemIndex > (Values.Count-1)) then Result := '' else Result := Values[I];
	  end;
end;


procedure TDbValueCombobox.Change;
begin
  FDataLink.Edit;
  inherited Change;
  FDataLink.Modified;
end;

procedure TDbValueCombobox.Click;
begin
  FDataLink.Edit;
  inherited Click;
  FDataLink.Modified;
end;

procedure TDbValueCombobox.DropDown;
begin
  FDataLink.Edit;
  inherited DropDown;
end;

function TDbValueCombobox.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TDbValueCombobox.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

function TDbValueCombobox.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

procedure TDbValueCombobox.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
end;

function TDbValueCombobox.GetReadOnly: Boolean;
begin
  Result := FDataLink.ReadOnly;
end;

procedure TDbValueCombobox.SetReadOnly(Value: Boolean);
begin
  FDataLink.ReadOnly := Value;
end;

function TDbValueCombobox.GetField: TField;
begin
  Result := FDataLink.Field;
end;

procedure TDbValueCombobox.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  if Key in [VK_BACK, VK_DELETE, VK_UP, VK_DOWN, 32..255] then
  begin
    if not FDataLink.Edit and (Key in [VK_UP, VK_DOWN]) then
      Key := 0;
  end;
end;

procedure TDbValueCombobox.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);
  if (Key in [#32..#255]) and (FDataLink.Field <> nil) and
    not FDataLink.Field.IsValidChar(Key) then
  begin
    MessageBeep(0);
    Key := #0;
  end;
  case Key of
    ^H, ^V, ^X, #32..#255:
      FDataLink.Edit;
    #27:
      begin
        FDataLink.Reset;
        SelectAll;
        Key := #0;
      end;
  end;
end;

procedure TDbValueCombobox.EditingChange(Sender: TObject);
begin
  SetEditReadOnly;
end;

procedure TDbValueCombobox.SetEditReadOnly;
begin
  if (Style in [csDropDown, csSimple]) and HandleAllocated then
    SendMessage(EditHandle, EM_SETREADONLY, Ord(not FDataLink.Editing), 0);
end;

procedure TDbValueCombobox.WndProc(var Message: TMessage);
begin
  if not (csDesigning in ComponentState) then
    case Message.Msg of
      WM_COMMAND:
        if TWMCommand(Message).NotifyCode = CBN_SELCHANGE then
          if not FDataLink.Edit then
          begin
            if Style <> csSimple then
              PostMessage(Handle, CB_SHOWDROPDOWN, 0, 0);
            Exit;
          end;
      CB_SHOWDROPDOWN:
        if Message.WParam <> 0 then FDataLink.Edit else
          if not FDataLink.Editing then DataChange(Self); {Restore text}
      WM_CREATE,
      WM_WINDOWPOSCHANGED,
      CM_FONTCHANGED:
        FPaintControl.DestroyHandle;
    end;
  inherited WndProc(Message);
end;

procedure TDbValueCombobox.ComboWndProc(var Message: TMessage; ComboWnd: HWnd;
  ComboProc: Pointer);
begin
  if not (csDesigning in ComponentState) then
    case Message.Msg of
      WM_LBUTTONDOWN:
        if (Style = csSimple) and (ComboWnd <> EditHandle) then
          if not FDataLink.Edit then Exit;
    end;
  inherited ComboWndProc(Message, ComboWnd, ComboProc);
end;

procedure TDbValueCombobox.CMExit(var Message: TCMExit);
begin
  try
    FDataLink.UpdateRecord;
  except
    SelectAll;
    SetFocus;
    raise;
  end;
  inherited;
end;

procedure TDbValueCombobox.WMPaint(var Message: TWMPaint);
var
  S: string;
  R: TRect;
  P: TPoint;
  Child: HWND;
begin
  if csPaintCopy in ControlState then
  begin
    if FDataLink.Field <> nil then S := FDataLink.Field.Text else S := '';
    if Style = csDropDown then
    begin
      SendMessage(FPaintControl.Handle, WM_SETTEXT, 0, Longint(PChar(S)));
      SendMessage(FPaintControl.Handle, WM_PAINT, Message.DC, 0);
      Child := GetWindow(FPaintControl.Handle, GW_CHILD);
      if Child <> 0 then
      begin
        Windows.GetClientRect(Child, R);
        Windows.MapWindowPoints(Child, FPaintControl.Handle, R.TopLeft, 2);
        GetWindowOrgEx(Message.DC, P);
        SetWindowOrgEx(Message.DC, P.X - R.Left, P.Y - R.Top, nil);
        IntersectClipRect(Message.DC, 0, 0, R.Right - R.Left, R.Bottom - R.Top);
        SendMessage(Child, WM_PAINT, Message.DC, 0);
      end;
    end else
    begin
      SendMessage(FPaintControl.Handle, CB_RESETCONTENT, 0, 0);
      if Items.IndexOf(S) <> -1 then
      begin
        SendMessage(FPaintControl.Handle, CB_ADDSTRING, 0, Longint(PChar(S)));
        SendMessage(FPaintControl.Handle, CB_SETCURSEL, 0, 0);
      end;
      SendMessage(FPaintControl.Handle, WM_PAINT, Message.DC, 0);
    end;
  end else
    inherited;
end;

procedure TDbValueCombobox.SetItems(Value: TStrings);
begin
  Items.Assign(Value);
  DataChange(Self);
end;

procedure TDbValueCombobox.SetStyle(Value: TComboboxStyle);
begin
  if (Value = csSimple) and Assigned(FDatalink) and FDatalink.DatasourceFixed then
    DBError(SNotReplicatable);
  inherited SetStyle(Value);
end;

procedure TDbValueCombobox.CMGetDatalink(var Message: TMessage);
begin
  Message.Result := Integer(FDataLink);
end;

procedure TDbValueCombobox.SetValues(Value: TStrings);{new procedure}
begin
  FValues.Assign(Value);
  DataChange(Self);
end;



end.
